/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.ParamCostoTarjeta;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.ParamCostoTarjetaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderSendaAmigoParamCostoTarjeta;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Paging;

/**
 *
 * @author Rafius //ParamCostoTarjeta
 */
@Controller("busquedaParamCostoTarjetaController")
@Scope("prototype")
public class BusquedaParamCostoTarjetaController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<ParamCostoTarjeta> plwParamCostoTarjeta;
    @Autowired
    private ParamCostoTarjetaService paramCostoTarjetaService;
    @Autowired
    private EmpresaService empresaService;
    private List<Empresa> lsEmpresa;
    private List<ParamCostoTarjeta> lsParamCostoTarjeta;
    private Combobox cmbEmpresa;
    private MyListbox paramCostoTarjetaList;
    private Paging pagingParamCostoTarjeta;

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        lsEmpresa =  UsuarioLogado.getUsuarioLogado().getEmpresa();

        super.doAfterCompose(comp);

        paramCostoTarjetaList.setItemRenderer(new RenderSendaAmigoParamCostoTarjeta());
        paramCostoTarjetaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                ParamCostoTarjeta pa = (ParamCostoTarjeta) paramCostoTarjetaList.getSelected();
                verParamCostoTarjeta(pa);
            }
        });

        lsParamCostoTarjeta = new ArrayList<ParamCostoTarjeta>();

        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verParamCostoTarjeta(new ParamCostoTarjeta());
    }

    private void verParamCostoTarjeta(ParamCostoTarjeta pa) {
        if (pa == null) {
            return;
        }

        Map args = new HashMap();
        args.put("BusquedaParamCostoTarjetaController", this);
        args.put("paramCostoTarjeta", pa);
        args.put("paramCostoTarjetaList", paramCostoTarjetaList);

        openWindow("/gui/senda_amigo/editarParamCostoTarjeta.zul",
                Labels.getLabel("busquedaParamCostoTarjetaController.window.title"), args, MODAL);
    }

    public void refreshLista() {
        HibernateSearchObject<ParamCostoTarjeta> tarifaBusqueda =
                new HibernateSearchObject<ParamCostoTarjeta>(ParamCostoTarjeta.class, pagingParamCostoTarjeta.getPageSize());
        tarifaBusqueda.addFilterEqual("activo", Boolean.TRUE);

        Comboitem cbiEmpresa = cmbEmpresa.getSelectedItem();
        if (cbiEmpresa != null) {
            Empresa empresa = (Empresa) cbiEmpresa.getValue();
            tarifaBusqueda.addFilterEqual("empresa", empresa);
        }else{
        	tarifaBusqueda.addFilterIn("empresa", lsEmpresa);
        }

        tarifaBusqueda.addSortAsc("empresa");

        plwParamCostoTarjeta.init(tarifaBusqueda, paramCostoTarjetaList, pagingParamCostoTarjeta);

        if (paramCostoTarjetaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaParamCostoTarjetaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public Paging getPagingParamCostoTarjeta() {
        return pagingParamCostoTarjeta;
    }

    public void setPagingParamCostoTarjeta(Paging pagingParamCostoTarjeta) {
        this.pagingParamCostoTarjeta = pagingParamCostoTarjeta;
    }

    public Combobox getCmbEmpresa() {
        return cmbEmpresa;
    }

    public void setCmbEmpresa(Combobox cmbEmpresa) {
        this.cmbEmpresa = cmbEmpresa;
    }

    public EmpresaService getEmpresaService() {
        return empresaService;
    }

    public void setEmpresaService(EmpresaService empresaService) {
        this.empresaService = empresaService;
    }

    public List<Empresa> getLsEmpresa() {
        return lsEmpresa;
    }

    public void setLsEmpresa(List<Empresa> lsEmpresa) {
        this.lsEmpresa = lsEmpresa;
    }

    public List<ParamCostoTarjeta> getLsParamCostoTarjeta() {
        return lsParamCostoTarjeta;
    }

    public void setLsParamCostoTarjeta(List<ParamCostoTarjeta> lsParamCostoTarjeta) {
        this.lsParamCostoTarjeta = lsParamCostoTarjeta;
    }

    public MyListbox getParamCostoTarjetaList() {
        return paramCostoTarjetaList;
    }

    public void setParamCostoTarjetaList(MyListbox paramCostoTarjetaList) {
        this.paramCostoTarjetaList = paramCostoTarjetaList;
    }

    public ParamCostoTarjetaService getParamCostoTarjetaService() {
        return paramCostoTarjetaService;
    }

    public void setParamCostoTarjetaService(ParamCostoTarjetaService paramCostoTarjetaService) {
        this.paramCostoTarjetaService = paramCostoTarjetaService;
    }

    public PagedListWrapper<ParamCostoTarjeta> getPlwParamCostoTarjeta() {
        return plwParamCostoTarjeta;
    }

    public void setPlwParamCostoTarjeta(PagedListWrapper<ParamCostoTarjeta> plwParamCostoTarjeta) {
        this.plwParamCostoTarjeta = plwParamCostoTarjeta;
    }
}
